load 'application'

before ->
    Post.findById req.params.id, (err, post) =>
        if err or not post
            redirect path_to.posts
        else
            @post = post
            next()
, only: ['show', 'edit', 'update', 'destroy']

# GET /posts/new
action 'new', ->
    @post = new Post
    @title = 'New post'
    render()

# POST /posts
action 'create', ->
    @post = new Post
    ['title', 'content', 'date', 'published'].forEach (field) =>
        @post[field] = req.body[field] if req.body[field]?

    @post.save (errors) ->
        if errors
            flash 'error', 'Post can not be created'
            render 'new',
                title: 'New post'
        else
            flash 'info', 'Post created'
            redirect path_to.posts

# GET /posts
action 'index', ->
    Post.find (err, posts) ->
        render
            posts: posts
            title: 'Posts index'

# GET /posts/:id
action 'show', ->
    @title = 'Show post'
    render()

# GET /posts/:id/edit
action 'edit', ->
    @title = 'Edit post details'
    render()

# PUT /posts/:id
action 'update', ->
    ['title', 'content', 'date', 'published'].forEach (field) =>
        @post[field] = req.body[field] if req.body[field]?

    @post.save (err) =>
        if not err
            flash 'info', 'Post updated'
            redirect path_to.post(@post)
        else
            flash 'error', 'Post can not be updated'
            render 'edit',
                title: 'Edit post details'

# DELETE /posts/:id
action 'destroy', ->
    @post.remove (error) ->
        if error
            flash 'error', 'Can not destroy post'
        else
            flash 'info', 'Post successfully removed'
        send "'" + path_to.posts + "'"
